#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <GDIPlus.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GuiEdit.au3>
#include <File.au3>
#include <Array.au3>
#include <GuiListBox.au3>

Opt("GUICloseOnESC", 1)


;#####ToDO#######################
;Fertig
;#####ToDo#######################


$GuiWidth = 320
$GuiHeight = 700
$GuiX = 500
$GuiY = 23
$title = "Taschenrechner by stayawayknight"
$temp = @ScriptDir & "\data\temp.tr"
$varpath = @ScriptDir & "\data\vars.tr"

$gui = GUICreate($title, $GuiWidth, $GuiHeight, $GuiX, $GuiY)
GUISetBkColor(0x16192C)
GUISetState(@SW_SHOW)
GUICtrlSetDefColor(0xFFFFFF)
GUICtrlSetDefBkColor(0x000000)


;####Hotkey Region Start
HotKeySet("{ENTER}", "ex")
HotKeySet("{1}{NUMPAD1}", "do1")
HotKeySet("{2}{NUMPAD2}", "do2")
HotKeySet("{3}{NUMPAD3}", "do3")
HotKeySet("{4}{NUMPAD4}", "do4")
HotKeySet("{5}{NUMPAD5}", "do5")
HotKeySet("{6}{NUMPAD6}", "do6")
HotKeySet("{7}{NUMPAD7}", "do7")
HotKeySet("{8}{NUMPAD8}", "do8")
HotKeySet("{9}{NUMPAD9}", "do9")
HotKeySet("{0}{NUMPAD0}", "do0")
HotKeySet("{.}{;}", "docom")
HotKeySet("{Backspace}{DEL}", "del")
HotKeySet("{(}", "klauf")
HotKeySet("{)}", "klzu")
HotKeySet("{+}", "plus")
HotKeySet("{-}", "minus")
HotKeySet("{*}", "mal")
HotKeySet("{/}", "geteilt")
HotKeySet("{^}", "hoch")
HotKeySet("{s}", "sinus")
HotKeySet("{c}", "cosinus")
HotKeySet("{t}", "tangens")
HotKeySet("{l}", "logarith")
;####Hotkey Region Ende



;####GDI Region Start
_GDIPlus_Startup()
$graphics = _GDIPlus_GraphicsCreateFromHWND($gui)
$trgraphic = _GDIPlus_ImageLoadFromFile(@ScriptDir & "\pic\taschenrechner.jpg")
_GDIPlus_GraphicsDrawImageRect($graphics, $trgraphic, 0, 0, $GuiWidth, $GuiHeight)
;####GDI Region Ende


;#### GUI Region Start
$Display = GUICtrlCreateEdit("", 35, 63, 247, 161, BitOR($ES_AUTOVSCROLL, $ES_AUTOHSCROLL, $ES_WANTRETURN, $ES_READONLY))
GUICtrlSetColor($Display, 0x000000) ;EINSTELLUNGEN
GUICtrlSetBkColor($Display, 0x44614B)
GUICtrlSetFont($Display, 11, 800, 0, "MS Sans Serif")
GUICtrlSetCursor($Display, 2)

$mal = GUICtrlCreateButton("*", 200, 640, 35, 28)  ;Block1
GUICtrlSetFont($mal, 8, 400, 0, "Calibri")
$geteilt = GUICtrlCreateButton("/", 250, 640, 35, 28)
GUICtrlSetFont($geteilt, 8, 400, 0, "Calibri")
$point = GUICtrlCreateButton(",", 50, 640, 35, 28)
GUICtrlSetFont($point, 8, 400, 0, "Calibri")
$0 = GUICtrlCreateButton("0", 100, 640, 35, 28)
GUICtrlSetFont($0, 8, 400, 0, "Calibri")
$do = GUICtrlCreateButton("Enter", 150, 640, 35, 28)
GUICtrlSetFont($do, 8, 400, 0, "Calibri")

$plus = GUICtrlCreateButton("+", 200, 600, 35, 28) ;Block2
GUICtrlSetFont($plus, 8, 400, 0, "Calibri")
$minus = GUICtrlCreateButton("-", 250, 600, 35, 28)
GUICtrlSetFont($minus, 8, 400, 0, "Calibri")
$1 = GUICtrlCreateButton("1", 50, 600, 35, 28)
GUICtrlSetFont($1, 8, 400, 0, "Calibri")
$2 = GUICtrlCreateButton("2", 100, 600, 35, 28)
GUICtrlSetFont($2, 8, 400, 0, "Calibri")
$3 = GUICtrlCreateButton("3", 150, 600, 35, 28)
GUICtrlSetFont($3, 8, 400, 0, "Calibri")

$4 = GUICtrlCreateButton("4", 50, 560, 35, 28) ;Block3
GUICtrlSetFont($4, 8, 400, 0, "Calibri")
$5 = GUICtrlCreateButton("5", 100, 560, 35, 28)
GUICtrlSetFont($5, 8, 400, 0, "Calibri")
$6 = GUICtrlCreateButton("6", 150, 560, 35, 28)
GUICtrlSetFont($6, 8, 400, 0, "Calibri")
$klauf = GUICtrlCreateButton("(", 200, 560, 35, 28)
GUICtrlSetFont($plus, 8, 400, 0, "Calibri")
$klzu = GUICtrlCreateButton(")", 250, 560, 35, 28)
GUICtrlSetFont($minus, 8, 400, 0, "Calibri")

$clear = GUICtrlCreateButton("Clear", 200, 520, 35, 28) ;Block4
GUICtrlSetFont($plus, 8, 400, 0, "Calibri")
$del = GUICtrlCreateButton("Del", 250, 520, 35, 28)
GUICtrlSetFont($minus, 8, 400, 0, "Calibri")
$7 = GUICtrlCreateButton("7", 50, 520, 35, 28)
GUICtrlSetFont($7, 8, 400, 0, "Calibri")
$8 = GUICtrlCreateButton("8", 100, 520, 35, 28)
GUICtrlSetFont($8, 8, 400, 0, "Calibri")
$9 = GUICtrlCreateButton("9", 150, 520, 35, 28)
GUICtrlSetFont($9, 8, 400, 0, "Calibri")

$sin = GUICtrlCreateButton("Sin", 50, 480, 35, 28) ;Block5
GUICtrlSetFont($7, 8, 400, 0, "Calibri")
$cos = GUICtrlCreateButton("Cos", 100, 480, 35, 28)
GUICtrlSetFont($8, 8, 400, 0, "Calibri")
$tan = GUICtrlCreateButton("Tan", 150, 480, 35, 28)
GUICtrlSetFont($9, 8, 400, 0, "Calibri")
$log = GUICtrlCreateButton("Log", 200, 480, 35, 28)
GUICtrlSetFont($plus, 8, 400, 0, "Calibri")
$hoch = GUICtrlCreateButton("^", 250, 480, 35, 28)
GUICtrlSetFont($minus, 8, 400, 0, "Calibri")

;$frei1 = GUICtrlCreateButton("", 50, 440, 35, 28) ;frei ;Block 6
;GUICtrlSetFont($7, 8, 400, 0, "Calibri")
;$frei2 = GUICtrlCreateButton("Werte", 100, 440, 35, 28);frei
;GUICtrlSetFont($8, 8, 400, 0, "Calibri")
;$frei3 = GUICtrlCreateButton("Reset", 150, 440, 35, 28);frei
;GUICtrlSetFont($9, 8, 400, 0, "Calibri")
$pi = GUICtrlCreateButton("Pi", 200, 440, 35, 28)
GUICtrlSetFont($plus, 8, 400, 0, "Calibri")
$wurzel = GUICtrlCreateButton("Wurzel", 250, 440, 35, 28)
GUICtrlSetFont($minus, 8, 400, 0, "Calibri")
;#### GUI Region Ende


GUIRegisterMsg($WM_PAINT, "wm_paint")
GUIRegisterMsg($WM_MOVE, "wm_paint")



While 1
	$msg = GUIGetMsg()
	Switch $msg
		Case $GUI_EVENT_CLOSE
			ende()

		Case $plus
			plus()

		Case $minus
			minus()

		Case $mal
			mal()

		Case $geteilt
			geteilt()

		Case $1
			do1()

		Case $2
			do2()

		Case $3
			do3()

		Case $4
			do4()

		Case $5
			do5()

		Case $6
			do6()

		Case $7
			do7()

		Case $8
			do8()

		Case $9
			do9()

		Case $0
			do0()

		Case $point
			docom()

		Case $do
			ex()

		Case $del
			del()

		Case $clear
			GUICtrlSetData($Display, "")

		Case $klauf
			klauf()

		Case $klzu
			klzu()

		Case $sin
			sinus()

		Case $cos
			cosinus()

		Case $tan
			tangens()

		Case $log
			logarith()

		Case $hoch
			hoch()

		Case $pi
			pi()

		Case $wurzel
			wurzel()



	EndSwitch
WEnd





Func ex()
	If FileExists($temp) Then ;Altes Ding lschen
		FileDelete($temp)
	EndIf


	$split = StringSplit(GUICtrlRead($Display), @CRLF, 3) ;Eintragen
	For $i = 0 To UBound($split) - 1 ;WRITE
		If StringRegExp($split[$i], "pi") = 1 Then
			$split[$i] = StringReplace($split[$i], "pi", "3.14159")
		EndIf
		IniWrite($temp, "zeilen", $i + 1, $split[$i]);WRITE
	Next;WRITE


	GUICtrlSetData($Display, "")
	For $z = 1 To _FileCountLines($temp) - 1 ;Lesen und verwerten
		$zeileninhalt = IniRead($temp, "zeilen", $z, "")
		If StringRegExp($zeileninhalt, "Erg") = 0 Then
			_GUICtrlEdit_AppendText($Display, $zeileninhalt)
			_GUICtrlEdit_AppendText($Display, @CRLF & "     Erg: " & Execute($zeileninhalt) & @CRLF)

		EndIf
	Next
EndFunc   ;==>ex





Func wm_paint()
	_GDIPlus_GraphicsDrawImageRect($graphics, $trgraphic, 0, 0, $GuiWidth, $GuiHeight)
	GUICtrlSetState($do, $GUI_ENABLE)
	GUICtrlSetState($1, $GUI_ENABLE)
	GUICtrlSetState($2, $GUI_ENABLE)
	GUICtrlSetState($3, $GUI_ENABLE)
	GUICtrlSetState($4, $GUI_ENABLE)
	GUICtrlSetState($5, $GUI_ENABLE)
	GUICtrlSetState($6, $GUI_ENABLE)
	GUICtrlSetState($7, $GUI_ENABLE)
	GUICtrlSetState($8, $GUI_ENABLE)
	GUICtrlSetState($9, $GUI_ENABLE)
	GUICtrlSetState($0, $GUI_ENABLE)
	GUICtrlSetState($klauf, $GUI_ENABLE)
	GUICtrlSetState($klzu, $GUI_ENABLE)
	GUICtrlSetState($clear, $GUI_ENABLE)
	GUICtrlSetState($del, $GUI_ENABLE)
	GUICtrlSetState($Display, $GUI_ENABLE)
	GUICtrlSetState($point, $GUI_ENABLE)
	GUICtrlSetState($plus, $GUI_ENABLE)
	GUICtrlSetState($minus, $GUI_ENABLE)
	GUICtrlSetState($geteilt, $GUI_ENABLE)
	GUICtrlSetState($mal, $GUI_ENABLE)
	GUICtrlSetState($wurzel, $GUI_ENABLE)
	GUICtrlSetState($log, $GUI_ENABLE)
	GUICtrlSetState($sin, $GUI_ENABLE)
	GUICtrlSetState($cos, $GUI_ENABLE)
	GUICtrlSetState($tan, $GUI_ENABLE)
	GUICtrlSetState($pi, $GUI_ENABLE)
	GUICtrlSetState($hoch, $GUI_ENABLE)
EndFunc   ;==>wm_paint


Func do1()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "1")
EndFunc   ;==>do1

Func do2()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "2")
EndFunc   ;==>do2

Func do3()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "3")
EndFunc   ;==>do3

Func do4()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "4")
EndFunc   ;==>do4

Func do5()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "5")
EndFunc   ;==>do5

Func do6()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "6")
EndFunc   ;==>do6

Func do7()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "7")
EndFunc   ;==>do7

Func do8()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "8")
EndFunc   ;==>do8

Func do9()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "9")
EndFunc   ;==>do9

Func do0()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "0")
EndFunc   ;==>do0

Func docom()
	GUICtrlSetData($Display, GUICtrlRead($Display) & ".")
EndFunc   ;==>docom

Func del()
	GUICtrlSetData($Display, StringLeft(GUICtrlRead($Display), StringLen(GUICtrlRead($Display)) - 1))
EndFunc   ;==>del

Func klauf()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "(")
EndFunc   ;==>klauf

Func klzu()
	GUICtrlSetData($Display, GUICtrlRead($Display) & ")")
EndFunc   ;==>klzu

Func plus()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "+")
EndFunc   ;==>plus

Func minus()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "-")
EndFunc   ;==>minus

Func mal()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "*")
EndFunc   ;==>mal

Func geteilt()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "/")
EndFunc   ;==>geteilt

Func sinus()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "Sin(")
EndFunc   ;==>sinus

Func cosinus()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "Cos(")
EndFunc   ;==>cosinus

Func tangens()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "Tan(")
EndFunc   ;==>tangens

Func hoch()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "^")
EndFunc   ;==>hoch

Func logarith()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "Log(")
EndFunc   ;==>logarith

Func pi()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "pi")
EndFunc   ;==>pi

Func wurzel()
	GUICtrlSetData($Display, GUICtrlRead($Display) & "Sqrt(")
EndFunc   ;==>wurzel





Func ende()
	_GDIPlus_Shutdown()
	_GDIPlus_GraphicsDispose($trgraphic)
	Exit
EndFunc   ;==>ende



